From 020ed5dcc166518a0fb48ee75c15f46ae7e2acee Mon Sep 17 00:00:00 2001
From: "Robert A. Burks" <rburksdev@gmail.com>
Date: Thu, 7 Mar 2024 02:40:22 -0500
Subject: [PATCH 13/31] 'trapped_write' no longer needs to be "harmonized"
 across the 'obarray'

Due to changes in the mechanics of 'trapped_write' flag handling in
other functions there is no longer the need to search every interned
symbol and follow every redirection when adding and removing variable
watcher functions.

* src/data.c (harmonize_variable_watchers):
Removed function as it is no longer required.
(Fadd_variable_watcher): Removed harmonizing.
(Fremove_variable_watcher): Removed harmonizing.
---
 src/data.c | 16 +---------------
 1 file changed, 1 insertion(+), 15 deletions(-)

diff --git a/src/data.c b/src/data.c
index 43b296ff343..fe9d097ec30 100644
--- a/src/data.c
+++ b/src/data.c
@@ -1830,15 +1830,6 @@ restore_symbol_trapped_write (Lisp_Object symbol)
   set_symbol_trapped_write (symbol, SYMBOL_TRAPPED_WRITE);
 }
 
-static void
-harmonize_variable_watchers (Lisp_Object alias, Lisp_Object base_variable)
-{
-  if (!EQ (base_variable, alias)
-      && EQ (base_variable, Findirect_variable (alias)))
-    set_symbol_trapped_write
-      (alias, XSYMBOL (base_variable)->u.s.trapped_write);
-}
-
 DEFUN ("add-variable-watcher", Fadd_variable_watcher, Sadd_variable_watcher,
        2, 2, 0,
        doc: /* Cause WATCH-FUNCTION to be called when SYMBOL is about to be set.
@@ -1858,8 +1849,6 @@ DEFUN ("add-variable-watcher", Fadd_variable_watcher, Sadd_variable_watcher,
   symbol = Findirect_variable (symbol);
   CHECK_SYMBOL (symbol);
   set_symbol_trapped_write (symbol, SYMBOL_TRAPPED_WRITE);
-  map_obarray (Vobarray, harmonize_variable_watchers, symbol);
-
   Lisp_Object watchers = Fget (symbol, Qwatchers);
   Lisp_Object member = Fmember (watch_function, watchers);
   if (NILP (member))
@@ -1878,10 +1867,7 @@ SYMBOL (or its aliases) are set.  */)
   Lisp_Object watchers = Fget (symbol, Qwatchers); /* CHECK_SYMBOL is in Fget */
   watchers = Fdelete (watch_function, watchers);
   if (NILP (watchers))
-    {
-      set_symbol_trapped_write (symbol, SYMBOL_UNTRAPPED_WRITE);
-      map_obarray (Vobarray, harmonize_variable_watchers, symbol);
-    }
+    set_symbol_trapped_write (symbol, SYMBOL_UNTRAPPED_WRITE);
   Fput (symbol, Qwatchers, watchers);
   return Qnil;
 }
-- 
2.34.1

